# encoding: utf-8
$LOAD_PATH.push(File.expand_path('../../lib', __FILE__))
require 'sinatra'
require 'geetest'

enable :sessions

captcha_id = 'd764fd5f1d8dc1be32eee54e75789384'
private_key = '667ffc1532e5925d1c3619f1f1adf8e7'

get '/' do
  redirect to('/embed')
end

get '/embed' do
  erb :'embed.html', layout: :'layout.html'
end

get '/popup' do
  erb :'popup.html', layout: :'layout.html'
end

get '/images/:filename' do
  send_file %(images/#{params[:filename]})
end

get '/:type/register' do
  user_id = nil # set here if can get user_id
  gt = Geetest::SDK3.new(captcha_id, private_key)
  status = gt.pre_process(user_id)
  session[gt.session_key] = status
  session['token'] = user_id || params[:avoid_cache_token]
  gt.response_str
end

post '/:type/validate' do
  gt = Geetest::SDK3.new(captcha_id, private_key)
  challenge = params[gt.fn_challenge]
  validate = params[gt.fn_validate]
  seccode = params[gt.fn_seccode]

  if session[gt.session_key]
    result = gt.success_validate(challenge, validate, seccode, session['token'])
  else
    result = gt.failback_validate(challenge, validate, seccode)
  end

  { status: (result ? 'login successfully' : 'login falied') }.to_json
end
